package org.jeecg.modules.database.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.annotation.RequiresPermissions;
import org.jeecg.common.api.vo.Result;
import org.jeecg.common.aspect.annotation.AutoLog;
import org.jeecg.common.system.base.controller.JeecgController;
import org.jeecg.common.system.query.QueryGenerator;
import org.jeecg.common.system.query.QueryRuleEnum;
import org.jeecg.modules.database.entity.Client;
import org.jeecg.modules.database.service.IClientService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.ModelAndView;

import java.util.*;

/**
 * @Description: 委托方
 * @Author: jeecg-boot
 * @Date: 2024-08-30
 * @Version: V1.0
 */
@Tag(name = "委托方")
@RestController
@RequestMapping("/database/client")
@Slf4j
public class ClientController extends JeecgController<Client, IClientService> {
    @Autowired
    private IClientService clientService;

    /**
     * 分页列表查询
     *
     * @param client
     * @param pageNo
     * @param pageSize
     * @param req
     * @return
     */
    //@AutoLog(value = "委托方-分页列表查询")
    @Operation(summary = "委托方-分页列表查询")
    @GetMapping(value = "/list")
    public Result<IPage<Client>> queryPageList(Client client,
                                               @RequestParam(name = "pageNo", defaultValue = "1") Integer pageNo,
                                               @RequestParam(name = "pageSize", defaultValue = "10") Integer pageSize,
                                               HttpServletRequest req) {
        Map<String, QueryRuleEnum> customeRuleMap = new HashMap<>();
        customeRuleMap.put("name", QueryRuleEnum.RIGHT_LIKE);
        QueryWrapper<Client> queryWrapper = QueryGenerator.initQueryWrapper(client, req.getParameterMap(), customeRuleMap);
        Page<Client> page = new Page<>(pageNo, pageSize);
        IPage<Client> pageList = clientService.page(page, queryWrapper);
        return Result.OK(pageList);
    }

    /**
     * 添加
     *
     * @param client
     * @return
     */
    @AutoLog(value = "委托方-添加")
    @Operation(summary = "委托方-添加")
    @RequiresPermissions("database:client:add")
    @PostMapping(value = "/add")
    public Result<String> add(@RequestBody Client client) {
        clientService.save(client);
        return Result.OK("添加成功！");
    }

    /**
     * 编辑
     *
     * @param client
     * @return
     */
    @AutoLog(value = "委托方-编辑")
    @Operation(summary = "委托方-编辑")
    @RequiresPermissions("database:client:edit")
    @RequestMapping(value = "/edit", method = {RequestMethod.PUT, RequestMethod.POST})
    public Result<String> edit(@RequestBody Client client) {
        clientService.updateById(client);
        return Result.OK("编辑成功!");
    }

    /**
     * 通过id删除
     *
     * @param id
     * @return
     */
    @AutoLog(value = "委托方-通过id删除")
    @Operation(summary = "委托方-通过id删除")
    @RequiresPermissions("database:client:delete")
    @DeleteMapping(value = "/delete")
    public Result<String> delete(@RequestParam(name = "id", required = true) String id) {
        clientService.removeById(id);
        return Result.OK("删除成功!");
    }

    /**
     * 批量删除
     *
     * @param ids
     * @return
     */
    @AutoLog(value = "委托方-批量删除")
    @Operation(summary = "委托方-批量删除")
    @RequiresPermissions("database:client:delete")
    @DeleteMapping(value = "/deleteBatch")
    public Result<String> deleteBatch(@RequestParam(name = "ids", required = true) String ids) {
        this.clientService.removeByIds(Arrays.asList(ids.split(",")));
        return Result.OK("批量删除成功!");
    }

    /**
     * 通过id查询
     *
     * @param id
     * @return
     */
    //@AutoLog(value = "委托方-通过id查询")
    @Operation(summary = "委托方-通过id查询")
    @GetMapping(value = "/queryById")
    public Result<Client> queryById(@RequestParam(name = "id", required = true) String id) {
        Client client = clientService.getById(id);
        if (client == null) {
            return Result.error("未找到对应数据");
        }
        return Result.OK(client);
    }

    /**
     * 导出excel
     *
     * @param request
     * @param client
     */

    @RequestMapping(value = "/exportXls")
    public ModelAndView exportXls(HttpServletRequest request, Client client) {
        return super.exportXls(request, client, Client.class, "委托方");
    }

    /**
     * 通过excel导入数据
     *
     * @param request
     * @param response
     * @return
     */
    @RequiresPermissions("database:client:add")
    @RequestMapping(value = "/importExcel", method = RequestMethod.POST)
    public Result<?> importExcel(HttpServletRequest request, HttpServletResponse response) {
        return super.importExcel(request, response, Client.class);
    }

}
